// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"


#pragma comment(lib, "SetupApi.lib")


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ~[ebNX
#define MUTEX_NAME			TEXT("BonDriver_Kuro")

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_TSDATA		0x0022004BUL	// TSXg[

// MTCY
#define TSDATASIZE			48128UL			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2UL											// obt@ = 2b
#define ASYNCBUFFSIZE		(0x400000UL / TSDATASIZE * ASYNCBUFFTIME)	// 32MbpsƂ

#define REQRESERVNUM		16UL			// 񓯊NGXg\
#define REQPOLLINGWAIT		10UL			// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00U			// NGXg
#define IORS_BUSY			0x01U			// NGXgM	
#define IORS_RECV			0x02U			// MAXgA҂


// hCoCX^XGUID
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_hMutex(NULL)
	, m_hDevice(INVALID_HANDLE_VALUE)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
{
	m_pThis = this;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	// UN[Y
	CloseTuner();

	// ̃vZXŃ`[iJĂ邩
	if(IsTunerOpening())return FALSE;

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE)))return FALSE;

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0UL;
	m_dwReadyReqNum = 0UL;

	try{
		// hCoI[v
		if((m_hDevice = FindFriioDriver(TRUE)) == INVALID_HANDLE_VALUE)throw 0UL;

		// Œ菉f[^M
		if(!SendFixedRequest(IDR_IOL_INISEQ))throw 1UL;

		// ftHg`lݒ
		if(!SetChannel(0UL, 0UL))throw 2UL;

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 3UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 4UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 5UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 6UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
		::wsprintf(szDebugOut, TEXT("BonDriver_Kuro: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000UL) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0UL);
			::OutputDebugString(TEXT("BonDriver_Kuro: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}		

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000UL) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0UL);
			::OutputDebugString(TEXT("BonDriver_Kuro: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}		

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}

	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	// IŒf[^M
	if(m_hDevice != INVALID_HANDLE_VALUE){
		SendFixedRequest(IDR_IOL_ENDSEQ);
		}

	// hCoN[Y
	if(m_hDevice != INVALID_HANDLE_VALUE){
		::CloseHandle(m_hDevice);
		m_hDevice = INVALID_HANDLE_VALUE;
		}

	// `l
	m_dwCurSpace = 0UL;
	m_dwCurChannel = 0UL;
	
	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	////////////////////////////////////////////////////////////////////
	// IBonDriverƂ̌݊ۂ߂Ɏb
	////////////////////////////////////////////////////////////////////

	if((bCh >= 13U) && (bCh <= 23U)){
		// BS
		return SetChannel(0U, bCh - 13U);
		}
	else if((bCh >= 24U) && (bCh <= 35U)){
		// 110CS
		return SetChannel(1U, bCh - 24U);
		}
	else{
		// Ή
		return FALSE;
		}
}

const float CBonTuner::GetSignalLevel(void)
{
	// Mxv
	static const BYTE GetLevReq[] = {0xC0, 0x02 ,0x00, 0x32, 0xBA, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// `⊮ŋߎ
	static const float afLevelTable[] =
	{
		24.07f,	// 00	00	0		24.07dB
		24.07f,	// 10	00	4096	24.07dB
		18.61f,	// 20	00	8192	18.61dB
		15.21f,	// 30	00	12288	15.21dB
		12.50f,	// 40	00	16384	12.50dB
		10.19f,	// 50	00	20480	10.19dB
		8.140f,	// 60	00	24576	8.140dB
		6.270f,	// 70	00	28672	6.270dB
		4.550f,	// 80	00	32768	4.550dB
		3.730f,	// 88	00	34816	3.730dB
		3.630f,	// 88	FF	35071	3.630dB
		2.940f,	// 90	00	36864	2.940dB
		1.420f,	// A0	00	40960	1.420dB
		0.000f	// B0	00	45056	-0.01dB
	};

	// Mobt@NA
	ZeroMemory(m_RxdBuff, sizeof(GetLevReq));

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)GetLevReq, sizeof(GetLevReq), m_RxdBuff, sizeof(GetLevReq)) == -1)return 0.0f;

	// MxvZ
	if(m_RxdBuff[40] <= 0x10U){
		// őNbv
		return 24.07f;
		}
	else if(m_RxdBuff[40] >= 0xB0U){
		// ŏNbv
		return 0.0f;
		}
	else{
		// `⊮
		const float fMixRate = (float)(((WORD)(m_RxdBuff[40] & 0x0FU) << 8) | (WORD)m_RxdBuff[41]) / 4095.0f;
		return afLevelTable[m_RxdBuff[40] >> 4] * (1.0f - fMixRate) + afLevelTable[(m_RxdBuff[40] >> 4) + 0x01U] * fMixRate;
		}
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0UL;
		*pdwRemain = 0UL;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0UL;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
	return TEXT("t[I");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ
	switch(dwSpace){
		case 0UL :	return TEXT("BS");
		case 1UL :	return TEXT("110CS");
		default  :	return NULL;		
		}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	switch(dwSpace){
		case 0UL :
			// BS
			switch(dwChannel){
				case 0UL :	return TEXT("BS1/TS0 BS");
				case 1UL :	return TEXT("BS1/TS1 BS-i");
				case 2UL :	return TEXT("BS3/TS0 WOWOW");
				case 3UL :	return TEXT("BS3/TS1 BSWp");
				case 4UL :	return TEXT("BS9/TS0 BS11");
				case 5UL :	return TEXT("BS9/TS1 Star Channel HV");
				case 6UL :	return TEXT("BS9/TS2 TwellV");
				case 7UL :	return TEXT("BS13/TS0 BSe");
				case 8UL :	return TEXT("BS13/TS1 BStW");
				case 9UL :	return TEXT("BS15/TS1 NHK BS1/2");
				case 10UL :	return TEXT("BS15/TS2 NHK BS-hi");
				}
	
			return NULL;
		
		case 1UL :
			// 110CS
			switch(dwChannel){
				case 0UL :	return TEXT("ND2 110CS #1");
				case 1UL :	return TEXT("ND4 110CS #2");
				case 2UL :	return TEXT("ND6 110CS #3");
				case 3UL :	return TEXT("ND8 110CS #4");
				case 4UL :	return TEXT("ND10 110CS #5");
				case 5UL :	return TEXT("ND12 110CS #6");
				case 6UL :	return TEXT("ND14 110CS #7");
				case 7UL :	return TEXT("ND16 110CS #8");
				case 8UL :	return TEXT("ND18 110CS #9");
				case 9UL :	return TEXT("ND20 110CS #10");
				case 10UL :	return TEXT("ND22 110CS #11");
				case 11UL :	return TEXT("ND24 110CS #12");
				}
		
			return NULL;
		
		default  :
			// Ή̃`[jO
			return NULL;
		}
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!EnumChannelName(dwSpace, dwChannel))return FALSE;

	// `[jOV[PXϕ
	static const BYTE PllConfA[] = {0x08, 0x08, 0x08, 0x08, 0x09, 0x09, 0x09, 0x0A, 0x0A, 0x0A, 0x0A, 0x0C, 0x0C, 0x0D, 0x0D, 0x0D, 0x0E, 0x0E, 0x0E, 0x0F, 0x0F, 0x0F, 0x10};	// 1/17 +40
	static const BYTE PllConfB[] = {0x32, 0x32, 0x80, 0x80, 0x64, 0x64, 0x64, 0x00, 0x00, 0x4C, 0x4C, 0x9A, 0xEA, 0x3A, 0x8A, 0xDA, 0x2A, 0x7A, 0xCA, 0x1A, 0x6A, 0xBA, 0x0A};	// 2/18 +40
	static const BYTE PllConfC[] = {0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};	// 75	+02
	static const BYTE PllConfD[] = {0x10, 0x11, 0x30, 0x31, 0x90, 0x91, 0x92, 0xD0, 0xD1, 0xF1, 0xF2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};	// 76	+02

	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(IDR_IOL_CHSEQ), TEXT("BINARY"));
	if(!hRsrc)return FALSE;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return FALSE;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return FALSE;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	const DWORD dwChIndex = dwSpace * 11UL + dwChannel;
	DWORD dwXmitNum = 0UL;
	DWORD dwXmited = 0UL;
	FixedIoReqHead *pIoReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pIoReqHead = (FixedIoReqHead *)pFixedBuff;
		pFixedBuff += sizeof(FixedIoReqHead);

		// Mf[^
		::CopyMemory(m_RxdBuff, pFixedBuff, pIoReqHead->wTxdSize);

		switch(dwXmitNum++){
			case 0UL :	m_RxdBuff[40] = PllConfA[dwChIndex];	break;
			case 1UL :	m_RxdBuff[40] = PllConfB[dwChIndex];	break;
			case 16UL :	m_RxdBuff[40] = PllConfA[dwChIndex];	break;
			case 17UL :	m_RxdBuff[40] = PllConfB[dwChIndex];	break;
			case 74UL :	m_RxdBuff[2] = PllConfC[dwChIndex];		break;
			case 75UL :	m_RxdBuff[2] = PllConfD[dwChIndex];		break;
			}

		// f[^M
		if(SendIoRequest(pIoReqHead->dwIoCode, m_RxdBuff, pIoReqHead->wTxdSize, m_RxdBuff, pIoReqHead->wRxdSize) == -1)return FALSE;
		pFixedBuff += pIoReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FixedIoReqHead) + pIoReqHead->wTxdSize);
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// TSf[^p[W
	PurgeTsStream();

	return TRUE;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const HANDLE CBonTuner::FindFriioDriver(const BOOL bSatellite)
{
	static const BYTE ChkDevReq[] = {0xC0, 0x02, 0x00, 0x30, 0x89, 0x00, 0x25, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x3A, 0x4B, 0x03, 0x00, 0x34, 0x08, 0x78, 0x00, 0x00, 0x40, 0x7F, 0xDC, 0xAC, 0x0F, 0x00, 0x00, 0x00, 0x01, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0xF4};

	// ړIFriiohCoĊJ
	TCHAR szDeviceName[_MAX_PATH];
	
	for(DWORD dwIndex = 0UL ; GetDriverPath((GUID *)&GUID_FRIIO_DRIVER, szDeviceName, dwIndex) ; dwIndex++){
		// hCoI[v
		if((m_hDevice = ::CreateFile(szDeviceName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) == INVALID_HANDLE_VALUE)continue;
		
		// NGXg𔭍sċ𒲂ׂ
		if(SendIoRequest(IOCODE_CONTROL, ChkDevReq, sizeof(ChkDevReq), m_RxdBuff, sizeof(ChkDevReq)) == sizeof(ChkDevReq)){

			// o͂͂
			switch(m_RxdBuff[74]){
				case 0xF4U : if(!bSatellite)return m_hDevice;	break;	// Friio
				case 0x0AU : if(bSatellite)return m_hDevice;	break;	// Friio
				default	   : break;
				}
			}

		::CloseHandle(m_hDevice);
		m_hDevice = INVALID_HANDLE_VALUE;
		}

	return INVALID_HANDLE_VALUE;
}

const BOOL CBonTuner::GetDriverPath(GUID *pGuid, LPTSTR lpszPath, const DWORD dwDeviceIndex)
{
	// GUIDfoCX̃pX擾

	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = ::SetupDiGetClassDevs(pGuid, 0UL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!::SetupDiEnumDeviceInterfaces(hDevInfo, NULL, pGuid, dwDeviceIndex, &DeviceInterfaceData)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
	DWORD dwBuffLen = 0UL;
	::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	// obt@m
	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	// foCX̃pX擾
	if(!::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXZbg̃nhJ
	::SetupDiDestroyDeviceInfoList(hDevInfo);

	// foCX̃pXRs[
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);

	return TRUE;
}

const int CBonTuner::SendIoRequest(const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(m_hDevice == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// Mf[^Rs[
	::CopyMemory(m_TxdBuff, pTxdData, dwTxdSize);

	// f[^M
	DWORD dwReturned = 0UL;
	const BOOL bRet = ::DeviceIoControl(m_hDevice, dwIoCode, m_TxdBuff, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bRet){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(m_hDevice, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

const BOOL CBonTuner::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), TEXT("BINARY"));
	if(!hRsrc)return FALSE;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return FALSE;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return FALSE;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0UL;
	FixedIoReqHead *pIoReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pIoReqHead = (FixedIoReqHead *)pFixedBuff;
		pFixedBuff += sizeof(FixedIoReqHead);

		// f[^M
		if(SendIoRequest(pIoReqHead->dwIoCode, pFixedBuff, pIoReqHead->wTxdSize, m_RxdBuff, pIoReqHead->wRxdSize) == -1)return FALSE;
		pFixedBuff += pIoReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FixedIoReqHead) + pIoReqHead->wTxdSize);
		}

	return TRUE;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2UL)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0UL ; dwIndex < (dwBuffNum - 1UL) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1UL];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	// TSf[^NGXg
	static const BYTE GetTsReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	CBonTuner *pThis = (CBonTuner *)pParam;

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s
			if(!pThis->PushIoRequest(IOCODE_TSDATA, (BYTE *)GetTsReq, sizeof(GetTsReq), TSDATASIZE)){
				// G[
				break;
				}

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}

	return 0UL;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){
			
			// NGXg
			if(!pThis->PopIoRequest()){
				// G[
				break;
				}
			}
		}

	return 0UL;
}

const BOOL CBonTuner::PushIoRequest(const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(m_hDevice == INVALID_HANDLE_VALUE)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwIoCode = dwIoCode;
	m_pIoPushReq->dwTxdSize = dwTxdSize;
	m_pIoPushReq->dwRxdSize = 0UL;
	if(dwTxdSize)::CopyMemory(m_pIoPushReq->TxdBuff, pTxdData, dwTxdSize);

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;

	// NGXgs
	if(!::DeviceIoControl(m_hDevice, dwIoCode, m_pIoPushReq->TxdBuff, dwTxdSize, m_pIoPushReq->RxdBuff, dwRxdSize, &m_pIoPushReq->dwRxdSize, &m_pIoPushReq->OverLapped)){
		if(::GetLastError() != ERROR_IO_PENDING){
			::CloseHandle(m_pIoPushReq->OverLapped.hEvent);
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(void)
{
	// 񓯊NGXg
	
	// I[v`FbN
	if(m_hDevice == INVALID_HANDLE_VALUE)return FALSE;
	
	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	const BOOL bRet = ::GetOverlappedResult(m_hDevice, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE);

	// G[`FbN
	if(!bRet){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	if(!bRet){
		// G[
		return FALSE;
		}

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}

