// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <Windows.h>
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"


#pragma comment(lib, "SetupApi.lib")


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ~[ebNX
#define MUTEX_NAME			TEXT("BonDriver_Shiro")

// hConhCfbNX
#define DEVICE_CONTROL		0x00U			// `[iRg[
#define DEVICE_STREAM		0x01U			// TSXg[

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020		// `[iRg[
#define IOCODE_TSDATA		0x0022004B		// TSXg[

// MTCY
#define TSDATASIZE			48128			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM		16				// 񓯊NGXg\
#define REQPOLLINGWAIT		10				// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂

// hCoMf[^
static const BYTE GetLevReq[] = {0xC0, 0x02, 0x00, 0x30, 0x89, 0x00, 0x25, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x3A, 0x4B, 0x03, 0x00, 0x34, 0x08, 0x78, 0x00, 0x00, 0x40, 0x7F, 0xDC, 0xAC, 0x0F, 0x00, 0x00, 0x00, 0x01, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0xF4};

// hCoCX^XGUID
DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_hMutex(NULL)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurChannel(0UL)
{
	m_pThis = this;

	// o
	m_hDevice[DEVICE_CONTROL] = INVALID_HANDLE_VALUE;
	m_hDevice[DEVICE_STREAM] = INVALID_HANDLE_VALUE;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	// UN[Y
	CloseTuner();

	// ̃vZXŃ`[iJĂ邩
	if(IsTunerOpening())return FALSE;

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	try{
		// hCoI[v
		m_hDevice[DEVICE_CONTROL] = FindFriioDriver(DEVICE_CONTROL, FALSE);
		m_hDevice[DEVICE_STREAM] = FindFriioDriver(DEVICE_STREAM, FALSE);
		if(m_hDevice[DEVICE_CONTROL] == INVALID_HANDLE_VALUE || m_hDevice[DEVICE_STREAM] == INVALID_HANDLE_VALUE)throw 0UL;

		// Œ菉f[^M
		if(!SendFixedRequest(IDR_IOL_INISEQ))throw 1UL;

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 2UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 3UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 4UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 5UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
		::wsprintf(szDebugOut, TEXT("BonDriver_Shiro: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_Shiro: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}		

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_Shiro: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}		

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	// IŒf[^M
	if(m_hDevice[DEVICE_CONTROL] != INVALID_HANDLE_VALUE){
		SendFixedRequest(IDR_IOL_ENDSEQ);
		}

	// hCoN[Y
	if(m_hDevice[DEVICE_CONTROL] != INVALID_HANDLE_VALUE){
		::CloseHandle(m_hDevice[DEVICE_CONTROL]);
		m_hDevice[DEVICE_CONTROL] = INVALID_HANDLE_VALUE;
		}

	if(m_hDevice[DEVICE_STREAM] != INVALID_HANDLE_VALUE){
		::CloseHandle(m_hDevice[DEVICE_STREAM]);
		m_hDevice[DEVICE_STREAM] = INVALID_HANDLE_VALUE;
		}

	// `l
	m_dwCurChannel = 0UL;
	
	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	////////////////////////////////////////////////////////////////////
	// IBonDriverƂ̌݊ۂ߂Ɏb
	////////////////////////////////////////////////////////////////////

	if(bCh < 13 || bCh > 62)return FALSE;
	else return SetChannel(0UL, bCh - 13U);
}

const float CBonTuner::GetSignalLevel(void)
{
	// Mobt@NA
	ZeroMemory(m_RxdBuff, sizeof(GetLevReq));

	// Mxv
	if(SendIoRequest(DEVICE_CONTROL, IOCODE_CONTROL, (BYTE *)GetLevReq, sizeof(GetLevReq), m_RxdBuff, sizeof(GetLevReq)) == -1)return 0.0f;

	// MxvZ
	const DWORD dwHex = ((DWORD)m_RxdBuff[40] << 16) | ((DWORD)m_RxdBuff[41] << 8) | (DWORD)m_RxdBuff[42];
	if(!dwHex)return 0.0f;

	return (float)(68.4344993f - log10((double)dwHex) * 10.0f + pow(log10((double)dwHex) - 5.045f, (double)4.0f) / 4.09f);
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
	return TEXT("t[I");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ
	switch(dwSpace){
		case 0UL :	return TEXT("nfW");
		default  :	return NULL;		
		}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	if(dwSpace || (dwChannel > 62UL))return NULL;

	static const TCHAR aszChannelName[][16] = 
	{
		TEXT("13ch"), TEXT("14ch"), TEXT("15ch"), TEXT("16ch"), TEXT("17ch"), TEXT("18ch"), TEXT("19ch"),
		TEXT("20ch"), TEXT("21ch"), TEXT("22ch"), TEXT("23ch"), TEXT("24ch"), TEXT("25ch"), TEXT("26ch"), TEXT("27ch"), TEXT("28ch"), TEXT("29ch"),
		TEXT("30ch"), TEXT("31ch"), TEXT("32ch"), TEXT("33ch"), TEXT("34ch"), TEXT("35ch"), TEXT("36ch"), TEXT("37ch"), TEXT("38ch"), TEXT("39ch"), 
		TEXT("40ch"), TEXT("41ch"), TEXT("42ch"), TEXT("43ch"), TEXT("44ch"), TEXT("45ch"), TEXT("46ch"), TEXT("47ch"), TEXT("48ch"), TEXT("49ch"), 
		TEXT("50ch"), TEXT("51ch"), TEXT("52ch"), TEXT("53ch"), TEXT("54ch"), TEXT("55ch"), TEXT("56ch"), TEXT("57ch"), TEXT("58ch"), TEXT("59ch"), 
		TEXT("60ch"), TEXT("61ch"), TEXT("62ch")
	};

	return aszChannelName[dwChannel];
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	if(!EnumChannelName(dwSpace, dwChannel))return FALSE;

	// `lύXNGXg
	static const BYTE ChSelReq1[] = {0x40, 0x03, 0x00, 0x30, 0xFE, 0x00, 0x05, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0xB2, 0x08};
	static const BYTE ChSelReq2[] = {0x40, 0x03, 0x00, 0x30, 0xFE, 0x00, 0x05, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x9A, 0x50};

	// `lf[^vZ
	const WORD wChCode = 0x0E7F + 0x002A * (WORD)dwChannel;

	BYTE TxdData[256];

	// 1ڃNGXgݒ
	CopyMemory(TxdData, ChSelReq1, sizeof(ChSelReq1));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 1ڃNGXgM
	if(SendIoRequest(DEVICE_CONTROL, IOCODE_CONTROL, TxdData, sizeof(ChSelReq1), m_RxdBuff, sizeof(ChSelReq1)) == -1)return FALSE;

	// 2ڃNGXgݒ
	CopyMemory(TxdData, ChSelReq2, sizeof(ChSelReq2));
	TxdData[39] = (BYTE)(wChCode >> 8);
	TxdData[40] = (BYTE)(wChCode & 0xFF);

	// 2ڃNGXgM
	if(SendIoRequest(DEVICE_CONTROL, IOCODE_CONTROL, TxdData, sizeof(ChSelReq2), m_RxdBuff, sizeof(ChSelReq2)) == -1)return FALSE;

	// `lݒŒf[^M
	if(!SendFixedRequest(IDR_IOL_CHSEQ))return FALSE;

	// `lXV
	m_dwCurChannel = dwChannel;

	// TSf[^p[W
	PurgeTsStream();

	return TRUE;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return 0UL;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const HANDLE CBonTuner::FindFriioDriver(const BYTE bDevice, const BOOL bSatellite)
{
	static const BYTE ChkDevReq[] = {0xC0, 0x02, 0x00, 0x30, 0x89, 0x00, 0x25, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x3A, 0x4B, 0x03, 0x00, 0x34, 0x08, 0x78, 0x00, 0x00, 0x40, 0x7F, 0xDC, 0xAC, 0x0F, 0x00, 0x00, 0x00, 0x01, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0xF4};

	// ړIFriiohCoĊJ
	TCHAR szDeviceName[_MAX_PATH];
	
	for(DWORD dwIndex = 0UL ; GetDriverPath((GUID *)&GUID_FRIIO_DRIVER, szDeviceName, dwIndex) ; dwIndex++){
		// hCoI[v
		if((m_hDevice[bDevice] = ::CreateFile(szDeviceName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) == INVALID_HANDLE_VALUE)continue;
		
		// NGXg𔭍sċ𒲂ׂ
		if(SendIoRequest(bDevice, IOCODE_CONTROL, ChkDevReq, sizeof(ChkDevReq), m_RxdBuff, sizeof(ChkDevReq)) == sizeof(ChkDevReq)){

			// o͂͂
			switch(m_RxdBuff[74]){
				case 0xF4U : if(!bSatellite)return m_hDevice[bDevice];	break;	// Friio
				case 0x0AU : if(bSatellite)return m_hDevice[bDevice];	break;	// Friio
				default	   : break;
				}
			}

		::CloseHandle(m_hDevice[bDevice]);
		m_hDevice[bDevice] = INVALID_HANDLE_VALUE;
		}

	return INVALID_HANDLE_VALUE;
}

const BOOL CBonTuner::GetDriverPath(GUID *pGuid, LPTSTR lpszPath, const DWORD dwDeviceIndex)
{
	// GUIDfoCX̃pX擾

	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = ::SetupDiGetClassDevs(pGuid, 0UL, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!::SetupDiEnumDeviceInterfaces(hDevInfo, NULL, pGuid, dwDeviceIndex, &DeviceInterfaceData)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
	DWORD dwBuffLen = 0UL;
	::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	// obt@m
	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	// foCX̃pX擾
	if(!::SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL)){
		::SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXZbg̃nhJ
	::SetupDiDestroyDeviceInfoList(hDevInfo);

	// foCX̃pXRs[
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);

	return TRUE;
}

const int CBonTuner::SendIoRequest(const BYTE bDevice, const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(m_hDevice[bDevice] == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// Mf[^Rs[
	::CopyMemory(m_TxdBuff, pTxdData, dwTxdSize);

	// f[^M
	DWORD dwReturned = 0;
	const BOOL bRet = ::DeviceIoControl(m_hDevice[bDevice], dwIoCode, m_TxdBuff, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bRet){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(m_hDevice[bDevice], &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

const BOOL CBonTuner::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), TEXT("BINARY"));
	if(!hRsrc)return FALSE;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return FALSE;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return FALSE;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0;
	FixedIoReqHead *pIoReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pIoReqHead = (FixedIoReqHead *)pFixedBuff;
		pFixedBuff += sizeof(FixedIoReqHead);

		// f[^M
		if(SendIoRequest(pIoReqHead->bDevice, pIoReqHead->dwIoCode, pFixedBuff, pIoReqHead->wTxdSize, m_RxdBuff, pIoReqHead->wRxdSize) == -1)return FALSE;
		pFixedBuff += pIoReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FixedIoReqHead) + pIoReqHead->wTxdSize);
		}

	return TRUE;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	// TSf[^NGXg
	static const BYTE GetTsReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	CBonTuner *pThis = (CBonTuner *)pParam;

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s
			if(!pThis->PushIoRequest(DEVICE_STREAM, IOCODE_TSDATA, (BYTE *)GetTsReq, sizeof(GetTsReq), TSDATASIZE)){
				// G[
				break;
				}

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}

	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){
			
			// NGXg
			if(!pThis->PopIoRequest()){
				// G[
				break;
				}
			}
		}

	return 0;
}

const BOOL CBonTuner::PushIoRequest(const BYTE bDevice, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(m_hDevice[bDevice] == INVALID_HANDLE_VALUE)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwDevice = (DWORD)bDevice;
	m_pIoPushReq->dwIoCode = dwIoCode;
	m_pIoPushReq->dwTxdSize = dwTxdSize;
	m_pIoPushReq->dwRxdSize = 0;
	if(dwTxdSize)::CopyMemory(m_pIoPushReq->TxdBuff, pTxdData, dwTxdSize);

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;

	// NGXgs
	if(!::DeviceIoControl(m_hDevice[bDevice], dwIoCode, m_pIoPushReq->TxdBuff, dwTxdSize, m_pIoPushReq->RxdBuff, dwRxdSize, &m_pIoPushReq->dwRxdSize, &m_pIoPushReq->OverLapped)){
		if(::GetLastError() != ERROR_IO_PENDING){
			::CloseHandle(m_pIoPushReq->OverLapped.hEvent);
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(void)
{
	// 񓯊NGXg
	
	// I[v`FbN
	if(m_hDevice[m_pIoPopReq->dwDevice] == INVALID_HANDLE_VALUE)return FALSE;
	
	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	const BOOL bRet = ::GetOverlappedResult(m_hDevice[m_pIoPopReq->dwDevice], &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE);

	// G[`FbN
	if(!bRet){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	if(!bRet){
		// G[
		return FALSE;
		}

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}

